******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #3 ZIP9TOCSGFORSCE.DO

clear
capture log close
set more off
set mem 1205m
log using "zip9tocbgforSCE.slf", replace text

u c:\billtiers\demographic_ca.dta
keep zip9 bg
sort zip9
save xxx,replace


u SCEannual

g double zip9=10000*zip+zip4
sort zip9
merge zip9 using xxx
tab _merge

drop if _merge==2
format zip9 %10.0f

keep zip9 bg _merge
sort zip9

drop if zip9==zip9[_n-1] &  _n~=1

drop if zip9==.

summ

sort zip9
g bgmatch=1
replace bgmatch=0 if bg==.

g double lastbg=bg
g double lastz9=zip9

summ

summ last* if lastbg==.

replace lastz9=lastz9[_n-1] if lastbg==.
replace lastbg=lastbg[_n-1] if lastbg==.

g double xzip9=-zip9
sort xzip9
g double nextbg=bg
g double nextz9=zip9

replace nextz9=nextz9[_n-1] if nextbg==.
replace nextbg=nextbg[_n-1] if nextbg==.

drop xzip9

sort zip9
replace bg=lastbg if bg==. & zip9-lastz9<=nextz9-zip9
replace bg=nextbg if bg==. & zip9-lastz9>nextz9-zip9

summ

keep zip9 bg
sort zip9
compress
save zip9toCBGforSCE, replace

exit
