******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #12 BILLCALC72RASS.DO

clear
capture log close
set more off
set mem 100m
log using "billcalc72RASS.slf", replace text

u billcalc5

keep if w==0 & (CARE==0 | CARE==1)
sort incW CARE 
g CAREshr=days/(days+days[_n-1]) if CARE==1
list incW CAREshr
clear

u billcalc5

drop if CARE==0
drop if CARE==1

g used=use/days
drop bill* avgP* use days
sort w incW CARE
g annbill1C=annbill1[_n+1] if CARE==-1
g annbill2C=annbill2[_n+1] if CARE==-1
g annbill5C=annbill5[_n+1] if CARE==-1

compress
sort w incW
drop if CARE==2
save billcalc72RASS, replace


****incW=1
u billcalc72RASS
keep if incW==1
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

g billIdiff=annbill5-annbill1
g billCdiff=annbill1C-annbill1
g billICdiff=annbill5C-annbill1
g billIgCdiff=billICdiff-billCdiff
g billCgIdiff=billICdiff-billIdiff
g CIdiff=billIdiff-billCdiff

g billIpct=annbill5/annbill1-1
g billCpct=annbill1C/annbill1-1
g billICpct=annbill5C/annbill1-1

summ used annbill1 annbill2 annbill5 annbill1C annbill2C annbill5C
summ billIdiff billCdiff billICdiff billIgCdiff billCgIdiff billIpct billCpct billICpct

centile billIdiff, centile(2.5,97.5)
centile billCdiff, centile(2.5,97.5)
centile billICdiff, centile(2.5,97.5)
centile billIgCdiff, centile(2.5,97.5)
centile billCgIdiff, centile(2.5,97.5)
centile CIdiff, centile(2.5,97.5)
centile billIpct, centile(2.5,97.5)
centile billCpct, centile(2.5,97.5)
centile billICpct, centile(2.5,97.5)

clear



****incW=2
u billcalc72RASS
keep if incW==2
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3


g billIdiff=annbill5-annbill1
g billCdiff=annbill1C-annbill1
g billICdiff=annbill5C-annbill1
g billIgCdiff=billICdiff-billCdiff
g billCgIdiff=billICdiff-billIdiff
g CIdiff=billIdiff-billCdiff

g billIpct=annbill5/annbill1-1
g billCpct=annbill1C/annbill1-1
g billICpct=annbill5C/annbill1-1

summ used annbill1 annbill2 annbill5 annbill1C annbill2C annbill5C
summ billIdiff billCdiff billICdiff billIgCdiff billCgIdiff billIpct billCpct billICpct

centile billIdiff, centile(2.5,97.5)
centile billCdiff, centile(2.5,97.5)
centile billICdiff, centile(2.5,97.5)
centile billIgCdiff, centile(2.5,97.5)
centile billCgIdiff, centile(2.5,97.5)
centile CIdiff, centile(2.5,97.5)
centile billIpct, centile(2.5,97.5)
centile billCpct, centile(2.5,97.5)
centile billICpct, centile(2.5,97.5)

clear


****incW=3
u billcalc72RASS
keep if incW==3
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3


g billIdiff=annbill5-annbill1
g billCdiff=annbill1C-annbill1
g billICdiff=annbill5C-annbill1
g billIgCdiff=billICdiff-billCdiff
g billCgIdiff=billICdiff-billIdiff
g CIdiff=billIdiff-billCdiff

g billIpct=annbill5/annbill1-1
g billCpct=annbill1C/annbill1-1
g billICpct=annbill5C/annbill1-1

summ used annbill1 annbill2 annbill5 annbill1C annbill2C annbill5C
summ billIdiff billCdiff billICdiff billIgCdiff billCgIdiff billIpct billCpct billICpct

centile billIdiff, centile(2.5,97.5)
centile billCdiff, centile(2.5,97.5)
centile billICdiff, centile(2.5,97.5)
centile billIgCdiff, centile(2.5,97.5)
centile billCgIdiff, centile(2.5,97.5)
centile CIdiff, centile(2.5,97.5)
centile billIpct, centile(2.5,97.5)
centile billCpct, centile(2.5,97.5)
centile billICpct, centile(2.5,97.5)

clear


****incW=4
u billcalc72RASS
keep if incW==4
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3


g billIdiff=annbill5-annbill1
g billCdiff=annbill1C-annbill1
g billICdiff=annbill5C-annbill1
g billIgCdiff=billICdiff-billCdiff
g billCgIdiff=billICdiff-billIdiff
g CIdiff=billIdiff-billCdiff

g billIpct=annbill5/annbill1-1
g billCpct=annbill1C/annbill1-1
g billICpct=annbill5C/annbill1-1

summ used annbill1 annbill2 annbill5 annbill1C annbill2C annbill5C
summ billIdiff billCdiff billICdiff billIgCdiff billCgIdiff billIpct billCpct billICpct

centile billIdiff, centile(2.5,97.5)
centile billCdiff, centile(2.5,97.5)
centile billICdiff, centile(2.5,97.5)
centile billIgCdiff, centile(2.5,97.5)
centile billCgIdiff, centile(2.5,97.5)
centile CIdiff, centile(2.5,97.5)
centile billIpct, centile(2.5,97.5)
centile billCpct, centile(2.5,97.5)
centile billICpct, centile(2.5,97.5)

clear


****incW=5
u billcalc72RASS
keep if incW==5
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3


g billIdiff=annbill5-annbill1
g billCdiff=annbill1C-annbill1
g billICdiff=annbill5C-annbill1
g billIgCdiff=billICdiff-billCdiff
g billCgIdiff=billICdiff-billIdiff
g CIdiff=billIdiff-billCdiff

g billIpct=annbill5/annbill1-1
g billCpct=annbill1C/annbill1-1
g billICpct=annbill5C/annbill1-1

summ used annbill1 annbill2 annbill5 annbill1C annbill2C annbill5C
summ billIdiff billCdiff billICdiff billIgCdiff billCgIdiff billIpct billCpct billICpct

centile billIdiff, centile(2.5,97.5)
centile billCdiff, centile(2.5,97.5)
centile billICdiff, centile(2.5,97.5)
centile billIgCdiff, centile(2.5,97.5)
centile billCgIdiff, centile(2.5,97.5)
centile CIdiff, centile(2.5,97.5)
centile billIpct, centile(2.5,97.5)
centile billCpct, centile(2.5,97.5)
centile billICpct, centile(2.5,97.5)

clear

u billcalc72RASS

sort w incW
list w incW used annbill1 annbill2 annbill5 if w>-0.0001 & w<0.0001 & CARE==-1
list w incW used annbill1 annbill2 annbill5 if w>0.9999 & CARE==-1

clear

u billcalc72RASS
keep if incW==1
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3
keep incW used ann*
save c:\temp\temp2, replace

u billcalc72RASS
keep if incW==2
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3
keep incW used ann*
append using c:\temp\temp2
save c:\temp\temp2, replace

u billcalc72RASS
keep if incW==3
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3
keep incW used ann*
append using c:\temp\temp2
save c:\temp\temp2, replace

u billcalc72RASS
keep if incW==4
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3
keep incW used ann*
append using c:\temp\temp2
save c:\temp\temp2, replace

u billcalc72RASS
keep if incW==5
sort w
save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3
keep incW used ann*
append using c:\temp\temp2
save c:\temp\temp2, replace

clear
u c:\temp\temp2
sort incW
collapse (mean) used ann*, by(incW)
list incW used annbill1 annbill2 annbill5 annbill1C annbill2C annbill5C



exit
