******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #17 CSCALC7A2.DO

clear
capture log close
set more off
set mem 100m
log using "cscalc7A2.slf", replace text

*****THIS PROGRAM IS USED TO CALC CHANGE IN CS FROM INTRODUCING IBP WHEN NO CARE PROGRAM EXISTS

****incW=1
u cscalc7
keep if incW==1
drop if CAREcase==1
drop CAREcase
sort w MC elas CARE 
summ
collapse (sum) days csbase csA qA (mean) PA, by(w MC elas)
summ
g dcs=365*(csbase-csA)/days


g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA qA csbase
reshape wide dcs PA, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PA*

g incW=1
keep dcs* incW PA*
save c:\temp\temp2, replace

clear


****incW=2
u cscalc7
keep if incW==2
drop if CAREcase==1
drop CAREcase
sort w MC elas CARE 
summ
collapse (sum) days csbase csA qA (mean) PA, by(w MC elas)
summ
g dcs=365*(csbase-csA)/days


g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA qA csbase
reshape wide dcs PA, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PA*

g incW=2
keep dcs* incW PA*
append using c:\temp\temp2
save c:\temp\temp2, replace

clear


****incW=3
u cscalc7
keep if incW==3
drop if CAREcase==1
drop CAREcase
sort w MC elas CARE 
summ
collapse (sum) days csbase csA qA (mean) PA, by(w MC elas)
summ
g dcs=365*(csbase-csA)/days


g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA qA csbase
reshape wide dcs PA, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PA*

g incW=3
keep dcs* incW PA*
append using c:\temp\temp2
save c:\temp\temp2, replace

clear


****incW=4
u cscalc7
keep if incW==4
drop if CAREcase==1
drop CAREcase
sort w MC elas CARE 
summ
collapse (sum) days csbase csA qA (mean) PA, by(w MC elas)
summ
g dcs=365*(csbase-csA)/days


g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA qA csbase
reshape wide dcs PA, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PA*

g incW=4
keep dcs* incW PA*
append using c:\temp\temp2
save c:\temp\temp2, replace

clear


****incW=5
u cscalc7
keep if incW==5
drop if CAREcase==1
drop CAREcase
sort w MC elas CARE 
summ
collapse (sum) days csbase csA qA (mean) PA, by(w MC elas)
summ
g dcs=365*(csbase-csA)/days


g MCe="060"
replace MCe="061" if MC>0.04 & MC<0.07 & elas<-0.09 & elas>-0.11
replace MCe="062" if MC>0.04 & MC<0.07 & elas<-0.19 & elas>-0.21
replace MCe="063" if MC>0.04 & MC<0.07 & elas<-0.29 & elas>-0.31
replace MCe="110" if MC>0.09 & MC<0.12 & elas<0.01 & elas>-0.01
replace MCe="111" if MC>0.09 & MC<0.12 & elas<-0.09 & elas>-0.11
replace MCe="112" if MC>0.09 & MC<0.12 & elas<-0.19 & elas>-0.21
replace MCe="113" if MC>0.09 & MC<0.12 & elas<-0.29 & elas>-0.31
replace MCe="160" if MC>0.14 & MC<0.17 & elas<0.01 & elas>-0.01
replace MCe="161" if MC>0.14 & MC<0.17 & elas<-0.09 & elas>-0.11
replace MCe="162" if MC>0.14 & MC<0.17 & elas<-0.19 & elas>-0.21
replace MCe="163" if MC>0.14 & MC<0.17 & elas<-0.29 & elas>-0.31
replace MCe="210" if MC>0.19 & MC<0.22 & elas<0.01 & elas>-0.01
replace MCe="211" if MC>0.19 & MC<0.22 & elas<-0.09 & elas>-0.11
replace MCe="212" if MC>0.19 & MC<0.22 & elas<-0.19 & elas>-0.21
replace MCe="213" if MC>0.19 & MC<0.22 & elas<-0.29 & elas>-0.31
replace MCe="260" if MC>0.24 & MC<0.27 & elas<0.01 & elas>-0.01
replace MCe="261" if MC>0.24 & MC<0.27 & elas<-0.09 & elas>-0.11
replace MCe="262" if MC>0.24 & MC<0.27 & elas<-0.19 & elas>-0.21
replace MCe="263" if MC>0.24 & MC<0.27 & elas<-0.29 & elas>-0.31
sort w
drop MC elas csA qA csbase
reshape wide dcs PA, i(w) j(MCe) string

save c:\temp\temp1, replace
u meanuseRASSsort
g w=wstar
replace w=w/100
sort w
merge w using c:\temp\temp1
tab _merge
drop if _merge~=3

summ dcs*
centile dcs*, centile(2.5,97.5)
summ PA*

g incW=5
keep dcs* incW PA*
append using c:\temp\temp2
save c:\temp\temp2, replace

clear

u c:\temp\temp2
sort incW
collapse (mean) dcs* PA*, by(incW)

list incW dcs110 dcs111 dcs112 dcs113
list PA110 PA111 PA112 PA113 if incW==1
list incW dcs160 dcs161 dcs162 dcs163
list PA160 PA161 PA162 PA163 if incW==1
list incW dcs210 dcs211 dcs212 dcs213
list PA210 PA211 PA212 PA213 if incW==1
list incW dcs260 dcs261 dcs262 dcs263
list PA260 PA261 PA262 PA263 if incW==1

exit
